/*****************************************************************************
 *                   SEGGER Microcontroller GmbH & Co. KG                    *
 *            Solutions for real time microcontroller applications           *
 *****************************************************************************
 *                                                                           *
 *               (c) 2017 SEGGER Microcontroller GmbH & Co. KG               *
 *                                                                           *
 *           Internet: www.segger.com   Support: support@segger.com          *
 *                                                                           *
 *****************************************************************************/

/*****************************************************************************
 *                         Preprocessor Definitions                          *
 *                         ------------------------                          *
 * VECTORS_IN_RAM                                                            *
 *                                                                           *
 *   If defined, an area of RAM will large enough to store the vector table  *
 *   will be reserved.                                                       *
 *                                                                           *
 *****************************************************************************/

  .syntax unified
  .code 16

  .section .init, "ax"
  .align 0

/*****************************************************************************
 * Default Exception Handlers                                                *
 *****************************************************************************/

  .thumb_func
  .weak NMI_Handler
NMI_Handler:
  b .

  .thumb_func
  .weak HardFault_Handler
HardFault_Handler:
  b .

  .thumb_func
  .weak SVC_Handler
SVC_Handler:
  b .

  .thumb_func
  .weak PendSV_Handler
PendSV_Handler:
  b .

  .thumb_func
  .weak SysTick_Handler
SysTick_Handler:
  b .

  .thumb_func
Dummy_Handler:
  b .

#if defined(__OPTIMIZATION_SMALL)

  .weak PMC_IRQHandler
  .thumb_set PMC_IRQHandler,Dummy_Handler

  .weak EFC_IRQHandler
  .thumb_set EFC_IRQHandler,Dummy_Handler

  .weak UART0_IRQHandler
  .thumb_set UART0_IRQHandler,Dummy_Handler

  .weak PIOA_IRQHandler
  .thumb_set PIOA_IRQHandler,Dummy_Handler

  .weak PIOB_IRQHandler
  .thumb_set PIOB_IRQHandler,Dummy_Handler

  .weak PIOC_IRQHandler
  .thumb_set PIOC_IRQHandler,Dummy_Handler

  .weak PIOD_IRQHandler
  .thumb_set PIOD_IRQHandler,Dummy_Handler

  .weak PIOE_IRQHandler
  .thumb_set PIOE_IRQHandler,Dummy_Handler

  .weak USART0_IRQHandler
  .thumb_set USART0_IRQHandler,Dummy_Handler

  .weak USART1_IRQHandler
  .thumb_set USART1_IRQHandler,Dummy_Handler

  .weak HSMCI_IRQHandler
  .thumb_set HSMCI_IRQHandler,Dummy_Handler

  .weak TWI0_IRQHandler
  .thumb_set TWI0_IRQHandler,Dummy_Handler

  .weak TWI1_IRQHandler
  .thumb_set TWI1_IRQHandler,Dummy_Handler

  .weak SPI_IRQHandler
  .thumb_set SPI_IRQHandler,Dummy_Handler

  .weak DMAC_IRQHandler
  .thumb_set DMAC_IRQHandler,Dummy_Handler

  .weak TC0_IRQHandler
  .thumb_set TC0_IRQHandler,Dummy_Handler

  .weak TC1_IRQHandler
  .thumb_set TC1_IRQHandler,Dummy_Handler

  .weak TC2_IRQHandler
  .thumb_set TC2_IRQHandler,Dummy_Handler

  .weak TC3_IRQHandler
  .thumb_set TC3_IRQHandler,Dummy_Handler

  .weak TC4_IRQHandler
  .thumb_set TC4_IRQHandler,Dummy_Handler

  .weak TC5_IRQHandler
  .thumb_set TC5_IRQHandler,Dummy_Handler

  .weak TC6_IRQHandler
  .thumb_set TC6_IRQHandler,Dummy_Handler

  .weak TC7_IRQHandler
  .thumb_set TC7_IRQHandler,Dummy_Handler

  .weak TC8_IRQHandler
  .thumb_set TC8_IRQHandler,Dummy_Handler

  .weak AFEC0_IRQHandler
  .thumb_set AFEC0_IRQHandler,Dummy_Handler

  .weak AFEC1_IRQHandler
  .thumb_set AFEC1_IRQHandler,Dummy_Handler

  .weak DACC_IRQHandler
  .thumb_set DACC_IRQHandler,Dummy_Handler

  .weak ACC_IRQHandler
  .thumb_set ACC_IRQHandler,Dummy_Handler

  .weak UDP_IRQHandler
  .thumb_set UDP_IRQHandler,Dummy_Handler

  .weak PWM_IRQHandler
  .thumb_set PWM_IRQHandler,Dummy_Handler

  .weak CAN0_IRQHandler
  .thumb_set CAN0_IRQHandler,Dummy_Handler

  .weak CAN1_IRQHandler
  .thumb_set CAN1_IRQHandler,Dummy_Handler

  .weak AES_IRQHandler
  .thumb_set AES_IRQHandler,Dummy_Handler

  .weak GMAC_IRQHandler
  .thumb_set GMAC_IRQHandler,Dummy_Handler

  .weak UART1_IRQHandler
  .thumb_set UART1_IRQHandler,Dummy_Handler

#else

  .thumb_func
  .weak PMC_IRQHandler
PMC_IRQHandler:
  b .

  .thumb_func
  .weak EFC_IRQHandler
EFC_IRQHandler:
  b .

  .thumb_func
  .weak UART0_IRQHandler
UART0_IRQHandler:
  b .

  .thumb_func
  .weak PIOA_IRQHandler
PIOA_IRQHandler:
  b .

  .thumb_func
  .weak PIOB_IRQHandler
PIOB_IRQHandler:
  b .

  .thumb_func
  .weak PIOC_IRQHandler
PIOC_IRQHandler:
  b .

  .thumb_func
  .weak PIOD_IRQHandler
PIOD_IRQHandler:
  b .

  .thumb_func
  .weak PIOE_IRQHandler
PIOE_IRQHandler:
  b .

  .thumb_func
  .weak USART0_IRQHandler
USART0_IRQHandler:
  b .

  .thumb_func
  .weak USART1_IRQHandler
USART1_IRQHandler:
  b .

  .thumb_func
  .weak HSMCI_IRQHandler
HSMCI_IRQHandler:
  b .

  .thumb_func
  .weak TWI0_IRQHandler
TWI0_IRQHandler:
  b .

  .thumb_func
  .weak TWI1_IRQHandler
TWI1_IRQHandler:
  b .

  .thumb_func
  .weak SPI_IRQHandler
SPI_IRQHandler:
  b .

  .thumb_func
  .weak DMAC_IRQHandler
DMAC_IRQHandler:
  b .

  .thumb_func
  .weak TC0_IRQHandler
TC0_IRQHandler:
  b .

  .thumb_func
  .weak TC1_IRQHandler
TC1_IRQHandler:
  b .

  .thumb_func
  .weak TC2_IRQHandler
TC2_IRQHandler:
  b .

  .thumb_func
  .weak TC3_IRQHandler
TC3_IRQHandler:
  b .

  .thumb_func
  .weak TC4_IRQHandler
TC4_IRQHandler:
  b .

  .thumb_func
  .weak TC5_IRQHandler
TC5_IRQHandler:
  b .

  .thumb_func
  .weak TC6_IRQHandler
TC6_IRQHandler:
  b .

  .thumb_func
  .weak TC7_IRQHandler
TC7_IRQHandler:
  b .

  .thumb_func
  .weak TC8_IRQHandler
TC8_IRQHandler:
  b .

  .thumb_func
  .weak AFEC0_IRQHandler
AFEC0_IRQHandler:
  b .

  .thumb_func
  .weak AFEC1_IRQHandler
AFEC1_IRQHandler:
  b .

  .thumb_func
  .weak DACC_IRQHandler
DACC_IRQHandler:
  b .

  .thumb_func
  .weak ACC_IRQHandler
ACC_IRQHandler:
  b .

  .thumb_func
  .weak UDP_IRQHandler
UDP_IRQHandler:
  b .

  .thumb_func
  .weak PWM_IRQHandler
PWM_IRQHandler:
  b .

  .thumb_func
  .weak CAN0_IRQHandler
CAN0_IRQHandler:
  b .

  .thumb_func
  .weak CAN1_IRQHandler
CAN1_IRQHandler:
  b .

  .thumb_func
  .weak AES_IRQHandler
AES_IRQHandler:
  b .

  .thumb_func
  .weak GMAC_IRQHandler
GMAC_IRQHandler:
  b .

  .thumb_func
  .weak UART1_IRQHandler
UART1_IRQHandler:
  b .

#endif

/*****************************************************************************
 * Vector Table                                                              *
 *****************************************************************************/

  .section .vectors, "ax"
  .align 0
  .global _vectors
  .extern __stack_end__
  .extern Reset_Handler

_vectors:
  .word __stack_end__
  .word Reset_Handler
  .word NMI_Handler
  .word HardFault_Handler
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word SVC_Handler
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word PendSV_Handler
  .word SysTick_Handler
  .word Dummy_Handler /* Reserved */
  .word Dummy_Handler /* Reserved */
  .word Dummy_Handler /* Reserved */
  .word Dummy_Handler /* Reserved */
  .word Dummy_Handler /* Reserved */
  .word PMC_IRQHandler
  .word EFC_IRQHandler
  .word UART0_IRQHandler
  .word Dummy_Handler /* Reserved */
  .word PIOA_IRQHandler
  .word PIOB_IRQHandler
  .word PIOC_IRQHandler
  .word PIOD_IRQHandler
  .word PIOE_IRQHandler
  .word USART0_IRQHandler
  .word USART1_IRQHandler
  .word HSMCI_IRQHandler
  .word TWI0_IRQHandler
  .word TWI1_IRQHandler
  .word SPI_IRQHandler
  .word DMAC_IRQHandler
  .word TC0_IRQHandler
  .word TC1_IRQHandler
  .word TC2_IRQHandler
  .word TC3_IRQHandler
  .word TC4_IRQHandler
  .word TC5_IRQHandler
  .word TC6_IRQHandler
  .word TC7_IRQHandler
  .word TC8_IRQHandler
  .word AFEC0_IRQHandler
  .word AFEC1_IRQHandler
  .word DACC_IRQHandler
  .word ACC_IRQHandler
  .word Dummy_Handler /* Reserved */
  .word UDP_IRQHandler
  .word PWM_IRQHandler
  .word CAN0_IRQHandler
  .word CAN1_IRQHandler
  .word AES_IRQHandler
  .word Dummy_Handler /* Reserved */
  .word Dummy_Handler /* Reserved */
  .word Dummy_Handler /* Reserved */
  .word Dummy_Handler /* Reserved */
  .word GMAC_IRQHandler
  .word UART1_IRQHandler
_vectors_end:

#ifdef VECTORS_IN_RAM
  .section .vectors_ram, "ax"
  .align 0
  .global _vectors_ram

_vectors_ram:
  .space _vectors_end - _vectors, 0
#endif
